
public class Algorithms
{
   public static Coordinates getCentroid(TriangleShape ts)
   {
      return new Coordinates(
         (ts.a.x + ts.b.x + ts.c.x) / 3.0,
         (ts.a.y + ts.b.y + ts.c.y) / 3.0,
         (ts.a.z + ts.b.z + ts.c.z) / 3.0
         );
   }

   public static Coordinates getNormal(TriangleShape ts)
   {
      Coordinates coords = new Coordinates();

      coords.x = (ts.a.y - ts.b.y) * (ts.a.z + ts.b.z) +
                 (ts.b.y - ts.c.y) * (ts.b.z + ts.c.z) +
                 (ts.c.y - ts.a.y) * (ts.c.z + ts.a.z);

      coords.y = (ts.a.z - ts.b.z) * (ts.a.x + ts.b.x) +
                 (ts.b.z - ts.c.z) * (ts.b.x + ts.c.x) +
                 (ts.c.z - ts.a.z) * (ts.c.x + ts.a.x);

      coords.z = (ts.a.x - ts.b.x) * (ts.a.y + ts.b.y) +
                 (ts.b.x - ts.c.x) * (ts.b.y + ts.c.y) +
                 (ts.c.x - ts.a.x) * (ts.c.y + ts.a.y);

      double l = coords.length();

      coords.x = coords.x / l;
      coords.y = coords.y / l;
      coords.z = coords.z / l;

      return coords;
   }

   public static Coordinates getLine(Coordinates coords1, Coordinates coords2)
   {
      Coordinates coords = new Coordinates(
         coords1.x - coords2.x,
         coords1.y - coords2.y,
         coords1.z - coords2.z
         );

      return coords.unitVector();
   }

   public static double dot(Coordinates coords1, Coordinates coords2)
   {
      return coords1.x * coords2.x +
         coords1.y * coords2.y +
         coords1.z * coords2.z;
   }
}
