
import java.awt.*;
import java.applet.*;
import java.util.*;

public class Main3 extends Applet
{
   public void init()
   {
      setBackground(Color.white);

      setLayout(new BorderLayout());

      // create the scene

      Scene scn = new Scene();

      // create the portal

      Port p = new Port3(scn);

      // create a beach umbrella

      double pi = Math.PI;

      double tpi = 2.0 * pi;

      double a = tpi / 10.00;

      TriangleShape ts;

      for (double i = 0.0; i < tpi; i += a)
      {
         double x0 = 0.0;
         double z0 = 0.0;

         double x1 = Math.cos(i) * 20.0;
         double z1 = Math.sin(i) * 20.0;

         double x2 = Math.cos(i + a) * 20.0;
         double z2 = Math.sin(i + a) * 20.0;

         double x3 = Math.cos(i) * 35.0;
         double z3 = Math.sin(i) * 35.0;

         double x4 = Math.cos(i + a) * 35.0;
         double z4 = Math.sin(i + a) * 35.0;

         ts = new TriangleShape(
              new Coordinates(   x0,   0.0,    z0),
              new Coordinates(   x1,  10.0,    z1),
              new Coordinates(   x2,  10.0,    z2)
            );

         scn.add(ts);

         ts = new TriangleShape(
              new Coordinates(   x1,  10.0,    z1),
              new Coordinates(   x3,  30.0,    z3),
              new Coordinates(   x4,  30.0,    z4)
            );

         scn.add(ts);

         ts = new TriangleShape(
              new Coordinates(   x1,  10.0,    z1),
              new Coordinates(   x4,  30.0,    z4),
              new Coordinates(   x2,  10.0,    z2)
            );

         scn.add(ts);
      }

      // move the beach umbrella into place

      scn.transform(new Translation(0.0, -100.0, 0.0));

      scn.transform(new Rotation(0.0, 0.0, 0.0, 0.0, 0.0, 1.0, -pi/10.0));

      // create a beach chair

      scn.add(new TriangleShape(
              new Coordinates(-50.0,  -5.0,  30.0),
              new Coordinates(-20.0, -15.0, -10.0),
              new Coordinates(-20.0, -15.0,  30.0)
         ));

      scn.add(new TriangleShape(
              new Coordinates(-50.0,  -5.0,  30.0),
              new Coordinates(-50.0,  -5.0, -10.0),
              new Coordinates(-20.0, -15.0, -10.0)
         ));

      scn.add(new TriangleShape(
              new Coordinates(-20.0, -15.0,  30.0),
              new Coordinates( 10.0,  -5.0, -10.0),
              new Coordinates( 10.0,  -5.0,  30.0)
         ));

      scn.add(new TriangleShape(
              new Coordinates(-20.0, -15.0,  30.0),
              new Coordinates(-20.0, -15.0, -10.0),
              new Coordinates( 10.0,  -5.0, -10.0)
         ));

      scn.add(new TriangleShape(
              new Coordinates( 10.0,  -5.0,  30.0),
              new Coordinates( 50.0, -25.0, -10.0),
              new Coordinates( 50.0, -25.0,  30.0)
         ));

      scn.add(new TriangleShape(
              new Coordinates( 10.0,  -5.0,  30.0),
              new Coordinates( 10.0,  -5.0, -10.0),
              new Coordinates( 50.0, -25.0, -10.0)
         ));

      // create the beach

      scn.add(new TriangleShape(
              new Coordinates(-60.0,  20.0,  60.0),
              new Coordinates(-60.0,  20.0, -60.0),
              new Coordinates( 60.0,  20.0,  60.0)
         ));

      scn.add(new TriangleShape(
              new Coordinates(-60.0,  20.0, -60.0),
              new Coordinates( 60.0,  20.0, -60.0),
              new Coordinates( 60.0,  20.0,  60.0)
         ));

      // don't forget your sun screen

      PortalPanel pp = new PortalPanel(p);

      add("Center", pp);
   }

   public Dimension preferredSize()
   {
      return new Dimension(400, 400);
   }

   public static void main(String [] args)
   {
      Frame f = new Frame("Main");

      Main3 m = new Main3();

      m.init();

      f.add("Center", m);

      f.pack();
      f.show();
   }
}
