
import java.awt.*;
import java.util.*;

public class Port1 extends Port
{
   public Port1(Scene scn)
   {
      super(scn);
   }

   public void paintScene(Graphics gr)
   {
      Enumeration enum = null;

      Object o = null;

      enum = getScene().elements();

      while (enum.hasMoreElements())
      {
         o = enum.nextElement();

         if (o instanceof Scenery)
         {
            Scenery sc = (Scenery)o;

            paintScene(gr, sc.elements());
         }
      }
   }

   private void paintScene(Graphics gr, Enumeration enum)
   {
      boolean fVisible = false;
      boolean fWasVisible = true;

      int x = 0;
      int y = 0;

      while (enum.hasMoreElements())
      {
         Dimension dim = size();

         Coordinates coords = (Coordinates)enum.nextElement();

         coords = addPerspective(coords);

         if (coords == null)
         {
            x = 0;
            y = 0;

            fVisible = false;

            continue;
         }

         int w = dim.width;
         int h = dim.height;

         int tx = (int)coords.x;
         int ty = (int)coords.y;
         int tz = (int)coords.z;

         if (fVisible && fWasVisible && isVisible(coords))
            gr.drawLine(x + w/2, y + h/2, tx + w/2, ty + h/2);

         fWasVisible = isVisible(coords);

         fVisible = true;

         x = tx;
         y = ty;
      }
   }
}
