
import java.awt.*;
import java.util.*;

public class Port2 extends Port
{
   public Port2(Scene scn)
   {
      super(scn);
   }

   private TriangleShapeQuickSort _tsqs = new TriangleShapeQuickSort();

   public void paintScene(Graphics gr)
   {
      Vector vec = new Vector();

      Object o = null;

      Enumeration enum = getScene().elements();

      while (enum.hasMoreElements())
      {
         o = enum.nextElement();

         if (o instanceof TriangleShape)
         {
            vec.addElement(o);
         }
      }

      Object [] rgo = new Object [ vec.size() ];

      vec.copyInto(rgo);

      _tsqs.sort(rgo);

      for (int i = 0; i < rgo.length; i++)
      {
         o = rgo[i];

         TriangleShape ts = (TriangleShape)o;

         paintScene(gr, ts);
      }
   }

   private void paintScene(Graphics gr, TriangleShape ts)
   {
      Dimension dim = size();

      Coordinates coordsA = addPerspective(ts.a);
      Coordinates coordsB = addPerspective(ts.b);
      Coordinates coordsC = addPerspective(ts.c);

      int w = dim.width;
      int h = dim.height;

      int [] rgx = new int [4];
      int [] rgy = new int [4];
      int [] rgz = new int [4];

      rgx[0] = (int)coordsA.x + w/2;
      rgy[0] = (int)coordsA.y + h/2;
      rgz[0] = (int)coordsA.z;

      rgx[1] = (int)coordsB.x + w/2;
      rgy[1] = (int)coordsB.y + h/2;
      rgz[1] = (int)coordsB.z;

      rgx[2] = (int)coordsC.x + w/2;
      rgy[2] = (int)coordsC.y + h/2;
      rgz[2] = (int)coordsC.z;

      rgx[3] = (int)coordsA.x + w/2;
      rgy[3] = (int)coordsA.y + h/2;
      rgz[3] = (int)coordsA.z;

      gr.setColor(getBackground());

      gr.fillPolygon(rgx, rgy, 4);

      gr.setColor(getForeground());

      gr.drawPolygon(rgx, rgy, 4);
   }
}
