
import java.util.*;
import java.awt.*;

/**
 * A triangular piece of scenery.
 */

public class TriangleShape extends Scenery
{
   public Coordinates a;
   public Coordinates b;
   public Coordinates c;

   private Vector _vec;

   /**
    * The constructor.
    */

   public TriangleShape(Coordinates a, Coordinates b, Coordinates c)
   {
      this.a = new Coordinates(a);
      this.b = new Coordinates(b);
      this.c = new Coordinates(c);

      _vec = new Vector(5);

      _vec.addElement(this.a);
      _vec.addElement(this.b);
      _vec.addElement(this.c);
      _vec.addElement(this.a);
      _vec.addElement(null);
   }

   /**
    * Set color.
    */

   private Hashtable _ht = null;

   public void setColor(Color color)
   {
      if (color == null) return;

      if (_ht == null) _ht = new Hashtable();

      _ht.put("color", color);
   }

   /**
    * Keep simple portals happy.
    */

   public Enumeration elements()
   {
      return _vec.elements();
   }

   /**
    * Apply the supplied transformation.
    */

   public void transform(Transformation tr)
   {
      tr.transform(a);
      tr.transform(b);
      tr.transform(c);
   }

   /**
    * Return any hints.
    */

   public Hashtable hints()
   {
      return _ht;
   }
}
